Bug 224129 - net-p2p/bitcoin: fails to build with boost 1.66
Summary: net-p2p/bitcoin: fails to build with boost 1.66
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Only Me
Assignee: Jan Beich
URL:
Keywords: needs-patch
Depends on:
Blocks: 223922
  Show dependency treegraph
 
Reported: 2017-12-05 21:18 UTC by Jan Beich
Modified: 2017-12-25 18:10 UTC (History)
1 user (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Jan Beich freebsd_committer 2017-12-05 21:18:56 UTC
As part of exp-run in bug 223922 this port was found to break on Boost update. If the issue won't disappear on its own by Boost release I plan to mark the port as BROKEN. Can you check with upstream maintainer or help with a fix?

$ fetch -qo- 'https://reviews.freebsd.org/D13279?download=true' | patch -Efsp0 -d /usr/ports
$ make all deinstall install clean -C/usr/ports/devel/boost-libs
$ make -C/usr/ports/net-p2p/bitcoin
[...]
In file included from miner.cpp:6:
In file included from ./miner.h:10:
In file included from ./txmempool.h:25:
In file included from /usr/local/include/boost/multi_index/ordered_index.hpp:17:
/usr/local/include/boost/multi_index/detail/ord_index_impl.hpp:1181:10: error: no matching function for call to object of type 'const key_compare' (aka 'const CompareModifiedEntry')
      if(comp_(key(v),key(y->value())))return false;
         ^~~~~
[...]
In file included from miner.cpp:6:
In file included from ./miner.h:10:
In file included from ./txmempool.h:25:
In file included from /usr/local/include/boost/multi_index/ordered_index.hpp:17:
/usr/local/include/boost/multi_index/detail/ord_index_impl.hpp:1186:26: error: no matching function for call to object of type 'const key_compare' (aka 'const CompareModifiedEntry')
    return y==header()||!comp_(key(y->value()),key(v));
                         ^~~~~
./miner.h:74:10: note: candidate function not viable: 'this' argument has type 'const key_compare' (aka 'const CompareModifiedEntry'), but method is not marked const
    bool operator()(const CTxMemPoolModifiedEntry &a, const CTxMemPoolModifiedEntry &b)
         ^

http://package23.nyi.freebsd.org/data/103i386-default-PR223922/2017-12-02_11h06m37s/logs/errors/bitcoin-0.15.1_1.log
http://package22.nyi.freebsd.org/data/103amd64-default-PR223922/2017-12-02_11h06m39s/logs/errors/bitcoin-0.15.1_1.log
http://package22.nyi.freebsd.org/data/111amd64-default-PR223922/2017-12-03_09h31m05s/logs/errors/bitcoin-0.15.1_1.log
http://package23.nyi.freebsd.org/data/111i386-default-PR223922/2017-12-03_09h31m14s/logs/errors/bitcoin-0.15.1_1.log

http://package23.nyi.freebsd.org/data/103i386-default-PR223922/2017-12-02_11h06m37s/logs/errors/bitcoin-daemon0.15.1_1.log
http://package22.nyi.freebsd.org/data/103amd64-default-PR223922/2017-12-02_11h06m39s/logs/errors/bitcoin-daemon0.15.1_1.log
http://package22.nyi.freebsd.org/data/111amd64-default-PR223922/2017-12-03_09h31m05s/logs/errors/bitcoin-daemon0.15.1_1.log
http://package23.nyi.freebsd.org/data/111i386-default-PR223922/2017-12-03_09h31m14s/logs/errors/bitcoin-daemon0.15.1_1.log

http://package23.nyi.freebsd.org/data/103i386-default-PR223922/2017-12-02_11h06m37s/logs/errors/bitcoin-utils0.15.1_1.log
http://package22.nyi.freebsd.org/data/103amd64-default-PR223922/2017-12-02_11h06m39s/logs/errors/bitcoin-utils0.15.1_1.log
http://package22.nyi.freebsd.org/data/111amd64-default-PR223922/2017-12-03_09h31m05s/logs/errors/bitcoin-utils0.15.1_1.log
http://package23.nyi.freebsd.org/data/111i386-default-PR223922/2017-12-03_09h31m14s/logs/errors/bitcoin-utils0.15.1_1.log
Comment 1 Jan Beich freebsd_committer 2017-12-05 21:21:08 UTC
It doesn't look like a Boost 1.66 issue given the following snippet builds fine:

#include "boost/multi_index_container.hpp"
#include "boost/multi_index/ordered_index.hpp"
#include "boost/multi_index/hashed_index.hpp"
#include <boost/multi_index/sequenced_index.hpp>

#include <boost/signals2/signal.hpp>

int main()
{  
  return 0;
}
Comment 2 commit-hook freebsd_committer 2017-12-25 18:08:36 UTC
A commit references this bug:

Author: jbeich
Date: Mon Dec 25 18:07:49 UTC 2017
New revision: 457245
URL: https://svnweb.freebsd.org/changeset/ports/457245

Log:
  net-p2p/bitcoin: unbreak with boost 1.66

  PR:		224129 224132
  Obtained from:	upstream (Bitcoin 0.16.0)
  Approved by:	portmgr blanket

Changes:
  head/net-p2p/bitcoin/Makefile
  head/net-p2p/bitcoin/distinfo
  head/net-p2p/litecoin/Makefile
  head/net-p2p/litecoin/distinfo
Comment 3 Jan Beich freebsd_committer 2017-12-25 18:10:34 UTC
Feedback timeout: maintainer failed to contact upstream.